/******************************************************************************
*
*  TrigInit.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  functions called when track is retriggered.  pointers to these functions are
*  placed in the a_Seq2 array.
*
******************************************************************************/

.MODULE                                     modTrigInit_00;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "ag0.h"

#define AG_CNF_TO_WTGEN2(meltrack) \
    AR = meltrack; \
    call agCalcNewFreq; \
    M2 = AR; \
    I3 = ^a_MIDIFreq; \
    modify(I3, M2); \
    AR = DM(I3, M0); \
    DM(a_WTGen2 + ((meltrack*WTGEN2_VARS)+WTGEN2_FREQ)) = AR

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      InitSQ0;
.ENTRY      InitSQ1;
.ENTRY      InitSQ2;

InitSQ0:
    RESET_PHASE_WTGEN2(0);
    AG_CNF_TO_WTGEN2(0);
    rts;
    
InitSQ1:
    RESET_PHASE_WTGEN2(1);
    AG_CNF_TO_WTGEN2(1);
    rts;
    
InitSQ2:
    RESET_PHASE_WTGEN2(2);
    AG_CNF_TO_WTGEN2(2);
    rts;

.ENDMOD;
