/******************************************************************************
*
*  GFPInit.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  generative music initializing pointer routine.  called at the beginning
*  of every audio processing loop.  a_GenFXPtrInits array filled in by
*  FillGenFXPtrInits (called in GenFXIni function).
*
******************************************************************************/

.MODULE                                 modPtrInits;

#include    ".\gen_fx\hdr\GenFX.h"   

/*
 *  entry points
 */
 
.ENTRY      GenFXPtrInits;

GenFXPtrInits:
    I4 = ^a_LSampOut;
    L4 = %a_LSampOut;
    !I7 = ^a_RSampOut;
    !L7 = %a_RSampOut;

    I7 = ^a_GenData;
    L7 = 0;

/*
 *  a_GenFXPtrInits[0]:  number of different sig gens
 *  a_GenFXPtrInits[1]:  start address of gen_fx param array
 *  a_GenFXPtrInits[2]:  address of ptr into specified gen_fx array
 */

    I2 = ^a_GenFXPtrInits + 1;
    CNTR = DM(a_GenFXPtrInits+0);
    do GPI until CE;
      AR = DM(I2, M1);
      AY0 = DM(I2, M1);
      I3 = AY0;
GPI:  DM(I3, M0) = AR;
    
    rts;
    
.ENDMOD;