/******************************************************************************
*
*  Clamp.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modClamp;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      ClampFX;

ClampFX:
    I2 = DM(p_ClampFX);
    AY0 = DM(I2, M1);
    DM(p_ClampFX) = I2;
    
    AR = DM(I7, M6);
    AR = pass AR;
    if LT jump NegClampFX;
    NONE = AR - AY0;
    if LT rts;
    
ClampPosOutput:
    DM(I7, M6) = AY0;
    rts;

NegClampFX:
    AR = -AR;
    NONE = AR - AY0;
    if LT rts;
    
ClampNegOutput:
    AR = -AY0;
    DM(I7, M6) = AR;
    rts;

.ENDMOD;