/*
 *  GenFX functions and associated vars
 */

#ifndef     GENFXVAR_FUNC
#ifndef     SONGVAR_FUNC

/* envelopes of various types */
.EXTERNAL   a_ADSRPanEnv;
.EXTERNAL   p_ADSRPanEnv;
.EXTERNAL   ADSRPanEnv;
.EXTERNAL   a_ExpDecayEnv;
.EXTERNAL   p_ExpDecayEnv;
.EXTERNAL   ExpDecayEnv;

/* signal generators */
.EXTERNAL   a_AlgoSineGen;
.EXTERNAL   p_AlgoSineGen;
.EXTERNAL   AlgoSineGen;
.EXTERNAL   a_AlgoSineSatGen;
.EXTERNAL   p_AlgoSineSatGen;
.EXTERNAL   AlgoSineSatGen;
.EXTERNAL   a_PerNoiseGen;
.EXTERNAL   p_PerNoiseGen;
.EXTERNAL   PerNoiseGen;
.EXTERNAL   a_WTGen;
.EXTERNAL   p_WTGen;
.EXTERNAL   WTGen;
.EXTERNAL   p_WTGen2;
.EXTERNAL   a_WTGen2;
.EXTERNAL   WTGen2;
.EXTERNAL   p_HPWTGen2;
.EXTERNAL   a_HPWTGen2;
.EXTERNAL   HPWTGen2;
.EXTERNAL   a_KSGen;
.EXTERNAL   p_KSGen;
.EXTERNAL   KSGen;
.EXTERNAL   a_ProbKSGen;
.EXTERNAL   p_ProbKSGen;
.EXTERNAL   ProbKSGen;
.EXTERNAL   a_OscCombGen;
.EXTERNAL   p_OscCombGen;
.EXTERNAL   OscCombGen;
.EXTERNAL   a_Exp1Gen;
.EXTERNAL   p_Exp1Gen;
.EXTERNAL   Exp1Gen;
.EXTERNAL   a_DelaySynthGen;
.EXTERNAL   p_DelaySynthGen;
.EXTERNAL   DelaySynthGen;
.EXTERNAL   a_TunedRotSynthGen;
.EXTERNAL   p_TunedRotSynthGen;
.EXTERNAL   TunedRotSynthGen;
.EXTERNAL   a_RotSynthGen;
.EXTERNAL   p_RotSynthGen;
.EXTERNAL   RotSynthGen;
.EXTERNAL   a_ProbSynthGen;
.EXTERNAL   p_ProbSynthGen;
.EXTERNAL   ProbSynthGen;
.EXTERNAL   a_ProbSynthGenMask;
.EXTERNAL   a_FM2Op0Gen;
.EXTERNAL   p_FM2Op0Gen;
.EXTERNAL   FM2Op0Gen;
.EXTERNAL   a_MultiGen;
.EXTERNAL   p_MultiGen;
.EXTERNAL   MultiGen;
.EXTERNAL   a_ExpImpulseGen;
.EXTERNAL   p_ExpImpulseGen;
.EXTERNAL   ExpImpulseGen;
.EXTERNAL   a_CopiedGen;
.EXTERNAL   p_CopiedGen;
.EXTERNAL   CopiedGen;
.EXTERNAL   ReadLeftInput;
.EXTERNAL   ReadRightInput;
.EXTERNAL   ReadBothMixedInputs;

.EXTERNAL   v_LSWSeed;
.EXTERNAL   v_MSWSeed;

/* useful buffers and LUTs */
.EXTERNAL   a_RandLUT;
.EXTERNAL   a_KSBuff0;
.EXTERNAL   a_KSBuff1;
.EXTERNAL   a_KSBuff2;
.EXTERNAL   a_KSBuff3;
.EXTERNAL   a_KSBuff4;
.EXTERNAL   a_KSBuff5;
.EXTERNAL   a_KSBuff6;
.EXTERNAL   a_KSBuff7;
.EXTERNAL   a_DelayBuff0;
.EXTERNAL   a_DelayBuff1;
.EXTERNAL   a_MIDIFreq;
.EXTERNAL   a_MIDIFreqKS;
.EXTERNAL   a_PerNoiseGenParam;
.EXTERNAL   a_WTSine;
.EXTERNAL   a_WTSq;
.EXTERNAL   a_WTTri;
.EXTERNAL   a_WTSaw;
.EXTERNAL   a_TrigTrack00;
.EXTERNAL   a_TrigTrack01;
.EXTERNAL   a_TrigTrack02;
.EXTERNAL   a_TrigTrack03;
.EXTERNAL   a_TrigTrack04;
.EXTERNAL   a_TrigTrack05;
.EXTERNAL   a_TrigTrack06;
.EXTERNAL   a_TrigTrack07;
.EXTERNAL   a_TrigTrack08;
.EXTERNAL   a_TrigTrack09;
.EXTERNAL   a_TrigTrack10;
.EXTERNAL   a_TrigTrack11;
.EXTERNAL   a_TrigTrack12;
.EXTERNAL   a_TrigTrack13;
.EXTERNAL   a_TrigTrack14;
.EXTERNAL   a_TrigTrack15;
.EXTERNAL   a_TrigTrack16;
.EXTERNAL   a_TrigTrack17;
.EXTERNAL   a_TrigTrack18;
.EXTERNAL   a_TrigTrack19;
.EXTERNAL   a_TrigTrack20;
.EXTERNAL   a_TrigTrack21;
.EXTERNAL   a_TrigTrack22;
.EXTERNAL   a_TrigTrack23;
.EXTERNAL   a_TrigTrack24;
.EXTERNAL   a_TrigTrack25;
.EXTERNAL   a_TrigTrack26;
.EXTERNAL   a_TrigTrack27;
.EXTERNAL   a_TrigTrack28;
.EXTERNAL   a_TrigTrack29;
.EXTERNAL   a_TrigTrack30;
.EXTERNAL   a_TrigTrack31;
.EXTERNAL   a_VolTrack00;
.EXTERNAL   a_VolTrack01;
.EXTERNAL   a_VolTrack02;
.EXTERNAL   a_VolTrack03;
.EXTERNAL   a_VolTrack04;
.EXTERNAL   a_VolTrack05;
.EXTERNAL   a_VolTrack06;
.EXTERNAL   a_VolTrack07;
.EXTERNAL   a_VolTrack08;
.EXTERNAL   a_VolTrack09;
.EXTERNAL   a_VolTrack10;
.EXTERNAL   a_VolTrack11;
.EXTERNAL   a_VolTrack12;
.EXTERNAL   a_VolTrack13;
.EXTERNAL   a_VolTrack14;
.EXTERNAL   a_VolTrack15;
.EXTERNAL   a_VolTrack16;
.EXTERNAL   a_VolTrack17;
.EXTERNAL   a_VolTrack18;
.EXTERNAL   a_VolTrack19;
.EXTERNAL   a_VolTrack20;
.EXTERNAL   a_VolTrack21;
.EXTERNAL   a_VolTrack22;
.EXTERNAL   a_VolTrack23;
.EXTERNAL   a_VolTrack24;
.EXTERNAL   a_VolTrack25;
.EXTERNAL   a_VolTrack26;
.EXTERNAL   a_VolTrack27;
.EXTERNAL   a_VolTrack28;
.EXTERNAL   a_VolTrack29;
.EXTERNAL   a_VolTrack30;
.EXTERNAL   a_VolTrack31;
.EXTERNAL   ap_CTRLTrack00;
.EXTERNAL   a_CTRLTrack00_0;
.EXTERNAL   ap_CTRLTrack01;
.EXTERNAL   a_CTRLTrack01_0;
.EXTERNAL   ap_CTRLTrack02;
.EXTERNAL   a_CTRLTrack02_0;
.EXTERNAL   ap_CTRLTrack03;
.EXTERNAL   a_CTRLTrack03_0;
.EXTERNAL   ap_CTRLTrack04;
.EXTERNAL   a_CTRLTrack04_0;
.EXTERNAL   ap_CTRLTrack05;
.EXTERNAL   a_CTRLTrack05_0;
.EXTERNAL   ap_CTRLTrack06;
.EXTERNAL   a_CTRLTrack06_0;
.EXTERNAL   ap_CTRLTrack07;
.EXTERNAL   a_CTRLTrack07_0;
.EXTERNAL   ap_CTRLTrack08;
.EXTERNAL   a_CTRLTrack08_0;
.EXTERNAL   ap_CTRLTrack09;
.EXTERNAL   a_CTRLTrack09_0;
.EXTERNAL   ap_CTRLTrack10;
.EXTERNAL   a_CTRLTrack10_0;
.EXTERNAL   ap_CTRLTrack11;
.EXTERNAL   a_CTRLTrack11_0;
.EXTERNAL   ap_CTRLTrack12;
.EXTERNAL   a_CTRLTrack12_0;
.EXTERNAL   ap_CTRLTrack13;
.EXTERNAL   a_CTRLTrack13_0;
.EXTERNAL   ap_CTRLTrack14;
.EXTERNAL   a_CTRLTrack14_0;
.EXTERNAL   ap_CTRLTrack15;
.EXTERNAL   a_CTRLTrack15_0;
.EXTERNAL   ap_CTRLTrack16;
.EXTERNAL   a_CTRLTrack16_0;
.EXTERNAL   ap_CTRLTrack17;
.EXTERNAL   a_CTRLTrack17_0;
.EXTERNAL   ap_CTRLTrack18;
.EXTERNAL   a_CTRLTrack18_0;
.EXTERNAL   ap_CTRLTrack19;
.EXTERNAL   a_CTRLTrack19_0;
.EXTERNAL   ap_CTRLTrack20;
.EXTERNAL   a_CTRLTrack20_0;
.EXTERNAL   ap_CTRLTrack21;
.EXTERNAL   a_CTRLTrack21_0;
.EXTERNAL   ap_CTRLTrack22;
.EXTERNAL   a_CTRLTrack22_0;
.EXTERNAL   ap_CTRLTrack23;
.EXTERNAL   a_CTRLTrack23_0;
.EXTERNAL   ap_CTRLTrack24;
.EXTERNAL   a_CTRLTrack24_0;
.EXTERNAL   ap_CTRLTrack25;
.EXTERNAL   a_CTRLTrack25_0;
.EXTERNAL   ap_CTRLTrack26;
.EXTERNAL   a_CTRLTrack26_0;
.EXTERNAL   ap_CTRLTrack27;
.EXTERNAL   a_CTRLTrack27_0;
.EXTERNAL   ap_CTRLTrack28;
.EXTERNAL   a_CTRLTrack28_0;
.EXTERNAL   ap_CTRLTrack29;
.EXTERNAL   a_CTRLTrack29_0;
.EXTERNAL   ap_CTRLTrack30;
.EXTERNAL   a_CTRLTrack30_0;
.EXTERNAL   ap_CTRLTrack31;
.EXTERNAL   a_CTRLTrack31_0;
.EXTERNAL   a_CTRLData;
.EXTERNAL   p_CTRLData;


/* system buffers and externals - use with caution! */
.EXTERNAL   a_GenData;
.EXTERNAL   p_GenData;
.EXTERNAL   a_RSampOut;
.EXTERNAL   a_LSampOut;
.EXTERNAL   a_LOutBuff0;
.EXTERNAL   a_LOutBuff1;
.EXTERNAL   a_ROutBuff0;
.EXTERNAL   a_ROutBuff1;
.EXTERNAL   p_LBuffToTX;
.EXTERNAL   p_RBuffToTX;
.EXTERNAL   a_GenFXPtrInits;
.EXTERNAL   p_GenFXPtrInits;
.EXTERNAL   b_EndSong;
.EXTERNAL   a_LAudioInBuff;
.EXTERNAL   p_LInAudioInBuff;
.EXTERNAL   p_LOutAudioInBuff;
.EXTERNAL   a_RAudioInBuff;
.EXTERNAL   p_RInAudioInBuff;
.EXTERNAL   p_ROutAudioInBuff;
.EXTERNAL   a_LMixScalars;
.EXTERNAL   a_RMixScalars;
.EXTERNAL   a_TempLMixScalars;
.EXTERNAL   a_TempRMixScalars;

/* memory modifiers */
.EXTERNAL   a_LFO3;
.EXTERNAL   p_LFO3;
.EXTERNAL   LFO3;
.EXTERNAL   v_NumLFO3;
.EXTERNAL   a_MemEnv3;
.EXTERNAL   p_MemEnv3;
.EXTERNAL   MemEnv3;
.EXTERNAL   v_NumMemEnv3;
.EXTERNAL   a_MemEnv1;
.EXTERNAL   p_MemEnv1;
.EXTERNAL   MemEnv1;
.EXTERNAL   v_NumMemEnv1;
.EXTERNAL   a_MemEnv2;
.EXTERNAL   p_MemEnv2;
.EXTERNAL   MemEnv2;
.EXTERNAL   v_NumMemEnv2;

/* fx */
.EXTERNAL   a_ClampFX;
.EXTERNAL   p_ClampFX;
.EXTERNAL   ClampFX;
.EXTERNAL   a_ZeroSampsFX;
.EXTERNAL   p_ZeroSampsFX;
.EXTERNAL   ZeroSampsFX;
.EXTERNAL   a_SVFFX;
.EXTERNAL   p_SVFFX;
.EXTERNAL   a_SVFFiltOut;
.EXTERNAL   p_SVFFiltOut;
.EXTERNAL   SVFFX;
.EXTERNAL   a_PrevCurrFiltFX;
.EXTERNAL   p_PrevCurrFiltFX;
.EXTERNAL   PrevCurrFiltFX;
.EXTERNAL   a_KillTimeFX;
.EXTERNAL   p_KillTimeFX;
.EXTERNAL   KillTimeFX;
.EXTERNAL   a_RectifyFX;
.EXTERNAL   p_RectifyFX;
.EXTERNAL   RectifyFX;
.EXTERNAL   a_BitMaskFX;
.EXTERNAL   p_BitMaskFX;
.EXTERNAL   BitmaskFX;
.EXTERNAL   a_GenSHFX;
.EXTERNAL   p_GenSHFX;
.EXTERNAL   GenSHFX;
.EXTERNAL   a_WTGenSyncFX;
.EXTERNAL   p_WTGenSyncFX;
.EXTERNAL   WTGenSyncFX;
.EXTERNAL   a_WaveShapeFX;
.EXTERNAL   p_WaveShapeFX;
.EXTERNAL   WaveShapeFX;

/* init/utility funcs */
.EXTERNAL   FillKS0Buff;
.EXTERNAL   FillKS1Buff;
.EXTERNAL   FillKS2Buff;
.EXTERNAL   FillKS3Buff;
.EXTERNAL   FillKS4Buff;
.EXTERNAL   FillKS5Buff;
.EXTERNAL   FillKS6Buff;
.EXTERNAL   FillKS7Buff;
.EXTERNAL   FillDB0;
.EXTERNAL   FillDB1;
.EXTERNAL   FillKS_JT;
.EXTERNAL   DummyRet;
.EXTERNAL   a_EnvTypes;
.EXTERNAL   GenFXIniPostProc;
.EXTERNAL   Seq2PostProc;
.EXTERNAL   FillGenFXPtrInits;
.EXTERNAL   USDivideNoRem;
.EXTERNAL   FRL;

/* misc vars */
.EXTERNAL   v_CurrSong;
.EXTERNAL   InitGMParamsPtr;
.EXTERNAL   GenFXPtr;
.EXTERNAL   SetFABCNTRPtr;
.EXTERNAL   ModFuncsPtr;
.EXTERNAL   MixerProcPtr;
.EXTERNAL   EnvProcPtr;
.EXTERNAL   v_NumSongs;
.EXTERNAL   v_Dummy;
.EXTERNAL   p_Vol;
.EXTERNAL   v_TrigOffset;
.EXTERNAL   v_CurrMeasure;
.EXTERNAL   v_TicsPerMeasure;
.EXTERNAL   v_TicCNTR;
.EXTERNAL   v_MeasuresPerSong;
.EXTERNAL   EndMeasure_JT;
.EXTERNAL   Measure_JT;
.EXTERNAL   v_NextSong;
.EXTERNAL   v_FABCNTR;
.EXTERNAL   v_LChanOut;
.EXTERNAL   v_RChanOut;
.EXTERNAL   LBasicMix;
.EXTERNAL   RBasicMix;
.EXTERNAL   p_LOutBuff;
.EXTERNAL   p_ROutBuff;

.EXTERNAL   FRL;

.EXTERNAL   a_Seq2;
.EXTERNAL   Seq2;
.EXTERNAL   a_TrackTriggered;

.EXTERNAL   InitTrack00;
.EXTERNAL   InitTrack01;
.EXTERNAL   InitTrack02;
.EXTERNAL   InitTrack03;
.EXTERNAL   InitTrack04;
.EXTERNAL   InitTrack05;
.EXTERNAL   InitTrack06;
.EXTERNAL   InitTrack07;
.EXTERNAL   InitTrack08;
.EXTERNAL   InitTrack09;
.EXTERNAL   InitTrack10;
.EXTERNAL   InitTrack11;
.EXTERNAL   InitTrack12;
.EXTERNAL   InitTrack13;
.EXTERNAL   InitTrack14;
.EXTERNAL   InitTrack15;
.EXTERNAL   InitTrack16;
.EXTERNAL   InitTrack17;
.EXTERNAL   InitTrack18;
.EXTERNAL   InitTrack19;
.EXTERNAL   InitTrack20;
.EXTERNAL   InitTrack21;
.EXTERNAL   InitTrack22;
.EXTERNAL   InitTrack23;
.EXTERNAL   InitTrack24;
.EXTERNAL   InitTrack25;
.EXTERNAL   InitTrack26;
.EXTERNAL   InitTrack27;
.EXTERNAL   InitTrack28;
.EXTERNAL   InitTrack29;
.EXTERNAL   InitTrack30;
.EXTERNAL   InitTrack31;

#endif
#endif
