/*****************************************************************************
*
*  ProbSyn.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
*****************************************************************************/

.MODULE                                     modProbSyn;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  external variables
 */


/*
 *  entry points
 */

.ENTRY      ProbSynthGen;

ProbSynthGen:
    I2 = DM(p_ProbSynthGen);
    AY0 = DM(I2, M1);                       /* prob refresh */
    AR = DM(I2, M0);                        /* current count */
    AR = AR + 1;
    DM(I2, M0) = AR;
    NONE = AR - AY0;
    if GT jump CalcNewOutput;
    
    modify(I2, M1);
    AR = DM(I2, M1);    
    DM(I7, M6) = AR;
    M2 = 8;
    modify(I2, M2);
    DM(p_ProbSynthGen) = I2;
    rts;
    
CalcNewOutput:
    DM(I2, M1) = 0;                         /* reset counter */
    I3 = I2;
    AR=pass 0, SI=DM(I2, M1);               /* dummy read, clear AR */
    MY0 = 50;

    I5 = ^a_ProbSynthGenMask;
    
    MX0 = DM(I6, M7);
    CNTR = 8;
    do PS1 until CE;
      AY0 = DM(I2, M1);
      MR=MX0*MY0(UU), AY1=DM(I5,M7);
      AF=MR1-AY0, MX0=DM(I6,M7);
PS1:  if LT AR = AR or AY1;

    DM(I3, M0) = AR;    
    DM(I7, M6) = AR;    
    DM(p_ProbSynthGen) = I2;
    
    rts;


.ENDMOD;
    